'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// This HoC creates the PageComponent prepared for the Client Side Rendering
// It renders a placeholder, if any specified as `renderLoading` on the PageComponent
// Also, executes the getInitialProps to retrieve the initialProps and then
// Renders the component with the initialProps, hiding the placeholder
exports.default = function (_ref) {
  var context = _ref.context,
      routeInfo = _ref.routeInfo;
  return function (Page) {
    var _class, _temp2;

    return _temp2 = _class = function (_Component) {
      (0, _inherits3.default)(ClientPage, _Component);

      function ClientPage() {
        var _ref2;

        var _temp, _this, _ret;

        (0, _classCallCheck3.default)(this, ClientPage);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = ClientPage.__proto__ || (0, _getPrototypeOf2.default)(ClientPage)).call.apply(_ref2, [this].concat(args))), _this), _this.state = { initialProps: {}, isLoading: true }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
      }

      (0, _createClass3.default)(ClientPage, [{
        key: '_renderLoading',
        value: function _renderLoading() {
          // check if the page has a renderLoading method, if not, just render nothing
          return Page.renderLoading ? Page.renderLoading() : null;
        }
      }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
          var _this2 = this;

          // get the initialProps by executing the provided method on the page
          // when got the results, update the state to re-render the page hiding the placeholder
          Page.getInitialProps({ context: context, routeInfo: routeInfo }).then(function (initialProps) {
            _this2.setState({ initialProps: initialProps, isLoading: false });
          }).catch(function (err) {
            // pass error as prop
            _this2.setState({ initialProps: { error: err }, isLoading: false });
          });
        }
      }, {
        key: 'render',
        value: function render() {
          return this.state.isLoading ? this._renderLoading() : _react2.default.createElement(Page, (0, _extends3.default)({}, this.state.initialProps, this.props));
        }
      }]);
      return ClientPage;
    }(_react.Component), _class.displayName = 'ClientPage(' + Page.displayName + ')', _temp2;
  };
};